#!/bin/sh
 CMD=pgrep
 PPROC=glmark2
 glmark2_old_pid="0"

 gfx_tid_amdgpu=$(ps -eLo tid,comm | grep gfx | awk '{print $1}')
 if [ -z "$gfx_tid_amdgpu" ] 
    then  echo "the driver is not amdgpu"
    exit
 fi

 while :
 do
    sudo inotifywait -rq -e 'open'  /dev/dri/renderD128

    glmark2_active_num=`pgrep glmark2 | wc -l`
    
    echo "glmark2_active_num: $glmark2_active_num"

    if [ "$glmark2_active_num" = "1" ]
        then glmark2_pid=`$CMD $PPROC`
        echo $glmark2_pid
        if [ -n "$glmark2_pid" ]
            then  echo "test is ok"
            if [ "$glmark2_pid" != "$glmark2_old_pid" ]
                then irqnum=$(cat /proc/interrupts |grep amdgpu | awk '{print $1}' |sed 's/://1')
                echo $irqnum
                cat /proc/irq/$irqnum/smp_affinity_list 
                echo 3 > /proc/irq/$irqnum/smp_affinity_list

 
                taskset -p 1 $glmark2_pid

                xorg_pid=$(pgrep Xorg)
                while [ -z "$xorg_pid" ] 
                do 
                    xorg_pid=$(pgrep Xorg)
                    echo "repeat to detect xorg_pid"
                done
                taskset -p 4 $xorg_pid

    
                xorg_cs0_tid=$(ps -eLo tid,comm | grep Xorg:cs0 | awk '{print $1}')
                while [ -z "$xorg_cs0_tid" ] 
                do 
                    xorg_cs0_tid=$(ps -eLo tid,comm | grep Xorg:cs0 | awk '{print $1}')
                    echo "repeat to detect xorg_cs0_tid"
                done
                taskset -p 4   $xorg_cs0_tid


                gfx_tid=$(ps -eLo tid,comm | grep gfx | awk '{print $1}')
                while [ -z "$gfx_tid" ] 
                do 
                    gfx_tid=$(ps -eLo tid,comm | grep gfx | awk '{print $1}')
                    echo "repeat to detect gfx_tid"
                done
                taskset -p 2   $gfx_tid                 

                 
                marco_tid=$(ps -eLo tid,comm | grep marco  | awk '{print $1}')
                while [ -z "$marco_tid" ] 
                do 
                     marco_tid=$(ps -eLo tid,comm | grep marco  | awk '{print $1}')
                    echo "repeat to detect marco_tid"
                done
                 taskset -p 8   $marco_tid


                glmark2_cs0_tid=$(ps -eLo tid,comm | grep glmark2:cs0  | awk '{print $1}')
                while [ -z "$glmark2_cs0_tid" ] 
                do 
                    glmark2_cs0_tid=$(ps -eLo tid,comm | grep glmark2:cs0  | awk '{print $1}')
                    echo "repeat to detect glmark2_cs0_tid"
                done
                 taskset -p 2   $glmark2_cs0_tid

                glmark2_old_pid=$glmark2_pid
                date '+%s %N'
            fi
        fi
    fi    
done
